<?php
/*--------------------------------------------+
| PHP-Fusion 6 - Content Management System    |
|---------------------------------------------|
| author: Nick Jones (Digitanium)  2002-2005 |
| web: http://www.php-fusion.co.uk            |
| email: nick@php-fusion.co.uk                |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/
/*----------------------------------------------+
| SECURITY SYSTEM V2 FR PHP-FUSION           |
| copyright (c) 2006 by BS-Fusion Deutschland   |
| Email-Support: webmaster[at]bs-fusion.de      |
| Homepage: http://www.bs-fusion.de             |
| Inhaber: Manuel Kurz                          |
+----------------------------------------------*/
if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }
if (file_exists(INFUSIONS."security_system/locale/".$settings['locale'].".php")) {
	include INFUSIONS."security_system/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."security_system/locale/German.php";
}
// Infusion general information
$inf_title = $locale['SYS100'];
$inf_description = $locale['SYS101'];
$inf_version = "1.7";
$inf_developer = "Silvermoon feat. CBACK.de";
$inf_email = "webmaster@bs-fusion.de";
$inf_weburl = "http://www.bs-fusion.de";

$inf_folder = "security_system"; // The folder in which the infusion resides.
$inf_admin_image = ""; // Leave blank to use the default image.
$inf_admin_panel = "admin/main.php"; // The admin panel filename if required.

$inf_newtables = 7;// Number of new db tables to create or drop.
$inf_insertdbrows = 110;// Numbers rows added into created db tables.

// Database table commands are stored in an array, the first table, or a single
// table must always be in array [0].

$inf_newtable_[1] = "secsys_filter (
    id INT(11) unsigned NOT NULL AUTO_INCREMENT ,
    list VARCHAR(255) NOT NULL,
    active TINYINT(1) unsigned NOT NULL DEFAULT '1',
    PRIMARY KEY  (id)
) TYPE=MyISAM;";

$inf_newtable_[2] = "secsys_settings (
  fctime INT(11) UNSIGNED NOT NULL,
  sctime INT(11) UNSIGNED NOT NULL,
  cctime INT(11) UNSIGNED NOT NULL,
  mctime INT(11) UNSIGNED NOT NULL,
  gctime INT(11) UNSIGNED NOT NULL,
  coctime INT(11) UNSIGNED NOT NULL,
  userlock SMALLINT(1) UNSIGNED NOT NULL,
  user_attempts SMALLINT(1) UNSIGNED NOT NULL,
  flood_active SMALLINT(1) UNSIGNED NOT NULL,
  forum_access MEDIUMINT(3) UNSIGNED NOT NULL,
  shout_access MEDIUMINT(3) UNSIGNED NOT NULL,
  comment_access MEDIUMINT(3) UNSIGNED NOT NULL,
  pm_access MEDIUMINT(3) UNSIGNED NOT NULL,
  contact_access MEDIUMINT(3) UNSIGNED NOT NULL,
  gb_access MEDIUMINT(3) UNSIGNED NOT NULL,
  version DECIMAL(16,1) NOT NULL,
  panel_set SMALLINT(1) NOT NULL,
  license_accept SMALLINT(1) NOT NULL,
  KEY version (version)
) TYPE=MyISAM;";


$inf_newtable_[3] = "secsys_contact (
    contact_id SMALLINT(5) unsigned NOT NULL AUTO_INCREMENT ,
    contact_datestamp INT(10) NOT NULL,
    contact_ip VARCHAR(20) NOT NULL,
    PRIMARY KEY  (contact_id)
) TYPE=MyISAM AUTO_INCREMENT=1;";

$inf_newtable_[4] = "secsys_logfile (
  hack_id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  hack_type VARCHAR(255) NOT NULL,
  hack_userid INT(11) UNSIGNED NOT NULL,
  hack_ip VARCHAR(20) NOT NULL,
  hack_query TEXT NOT NULL,
  hack_referer TEXT NOT NULL,
  hack_agent TEXT NOT NULL,
  hack_datestamp INT(10) NOT NULL,
  PRIMARY KEY (hack_id)
) TYPE=MyISAM;";

$inf_newtable_[5] = "secsys_statistics (
  hacks INT(11) UNSIGNED NOT NULL,
  floods INT(11) UNSIGNED NOT NULL,
  blocks INT(11) UNSIGNED NOT NULL,
  spams INT(11) UNSIGNED NOT NULL
) TYPE=MyISAM;";

$inf_newtable_[6] = "secsys_membercontrol (
  c_user_id INT(10) UNSIGNED NOT NULL,
  c_flood_count SMALLINT(1) NOT NULL,
  c_userlock SMALLINT(1) NOT NULL DEFAULT 0,
  c_userlock_datestamp INT(10) NOT NULL,
  PRIMARY KEY (c_user_id)
) TYPE=MyISAM;";

$inf_newtable_[7] = "secsys_spamfilter (
  spam_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  spam_word VARCHAR(255) NOT NULL,
  PRIMARY KEY (spam_id)
) TYPE=MyISAM AUTO_INCREMENT=1;";

$inf_insertdbrow_[1]="secsys_filter VALUES (1, 'Aqua_Products',1)";
$inf_insertdbrow_[2]="secsys_filter VALUES (2, 'asterias',1)";
$inf_insertdbrow_[3]="secsys_filter VALUES (3, 'b2w',1)";
$inf_insertdbrow_[4]="secsys_filter VALUES (4, 'BackDoorBot',1)";
$inf_insertdbrow_[5]="secsys_filter VALUES (5, 'Bait & Tackle',1)";
$inf_insertdbrow_[6]="secsys_filter VALUES (6, 'BlowFish',1)";
$inf_insertdbrow_[7]="secsys_filter VALUES (7, 'Bookmark search tool',1)";
$inf_insertdbrow_[8]="secsys_filter VALUES (8, 'BotALot',1)";
$inf_insertdbrow_[9]="secsys_filter VALUES (9, 'BruteForce',1)";
$inf_insertdbrow_[10]="secsys_filter VALUES (10, 'BuiltBotTough',1)";
$inf_insertdbrow_[11]="secsys_filter VALUES (11, 'BullsEye',1)";
$inf_insertdbrow_[12]="secsys_filter VALUES (12, 'BunnySlippers',1)";
$inf_insertdbrow_[13]="secsys_filter VALUES (13, 'CheeseBot',1)";
$inf_insertdbrow_[14]="secsys_filter VALUES (14, 'CherryPicker',1)";
$inf_insertdbrow_[15]="secsys_filter VALUES (15, 'CopyRightCheck',1)";
$inf_insertdbrow_[16]="secsys_filter VALUES (16, 'cosmos',1)";
$inf_insertdbrow_[17]="secsys_filter VALUES (17, 'Crescent',1)";
$inf_insertdbrow_[18]="secsys_filter VALUES (18, 'DigExt',1)";
$inf_insertdbrow_[19]="secsys_filter VALUES (19, 'DittoSpyder',1)";
$inf_insertdbrow_[20]="secsys_filter VALUES (20, 'EmailCollector',1)";
$inf_insertdbrow_[21]="secsys_filter VALUES (21, 'EmailSiphon',1)";
$inf_insertdbrow_[22]="secsys_filter VALUES (22, 'EmailWolf',1)";
$inf_insertdbrow_[23]="secsys_filter VALUES (23, 'EroCrawler',1)";
$inf_insertdbrow_[24]="secsys_filter VALUES (24, 'ExtractorPro',1)";
$inf_insertdbrow_[25]="secsys_filter VALUES (25, 'FairAd Client',1)";
$inf_insertdbrow_[26]="secsys_filter VALUES (26, 'Flaming AttackBot',1)";
$inf_insertdbrow_[27]="secsys_filter VALUES (27, 'Foobot',1)";
$inf_insertdbrow_[28]="secsys_filter VALUES (28, 'Gaisbot',1)";
$inf_insertdbrow_[29]="secsys_filter VALUES (29, 'GetRight',1)";
$inf_insertdbrow_[30]="secsys_filter VALUES (30, 'grup',1)";
$inf_insertdbrow_[31]="secsys_filter VALUES (31, 'grub-client',1)";
$inf_insertdbrow_[32]="secsys_filter VALUES (32, 'Harvest/1.5',1)";
$inf_insertdbrow_[33]="secsys_filter VALUES (33, 'hloader',1)";
$inf_insertdbrow_[34]="secsys_filter VALUES (34, 'httplib',1)";
$inf_insertdbrow_[35]="secsys_filter VALUES (35, 'HTTrack',1)";
$inf_insertdbrow_[36]="secsys_filter VALUES (36, 'humanlinks',1)";
$inf_insertdbrow_[37]="secsys_filter VALUES (37, 'ia_archiver',1)";
$inf_insertdbrow_[38]="secsys_filter VALUES (38, 'InfoNaviRobot',1)";
$inf_insertdbrow_[39]="secsys_filter VALUES (39, 'Iron33',1)";
$inf_insertdbrow_[40]="secsys_filter VALUES (40, 'JennyBot',1)";
$inf_insertdbrow_[41]="secsys_filter VALUES (41, 'Kenjin Spider',1)";
$inf_insertdbrow_[42]="secsys_filter VALUES (42, 'Keyword Density',1)";
$inf_insertdbrow_[43]="secsys_filter VALUES (43, 'larbin',1)";
$inf_insertdbrow_[44]="secsys_filter VALUES (44, 'LexiBot',1)";
$inf_insertdbrow_[45]="secsys_filter VALUES (45, 'libWeb/clsHTTP',1)";
$inf_insertdbrow_[46]="secsys_filter VALUES (46, 'LinkextractorPro',1)";
$inf_insertdbrow_[47]="secsys_filter VALUES (47, 'LinkScan',1)";
$inf_insertdbrow_[48]="secsys_filter VALUES (48, 'LinkWalker',1)";
$inf_insertdbrow_[49]="secsys_filter VALUES (49, 'LNSpiderguy',1)";
$inf_insertdbrow_[50]="secsys_filter VALUES (50, 'looksmart',1)";
$inf_insertdbrow_[51]="secsys_filter VALUES (51, 'lwp',1)";
$inf_insertdbrow_[52]="secsys_filter VALUES (52, 'Mata Hari',1)";
$inf_insertdbrow_[53]="secsys_filter VALUES (53, 'URL Control',1)";
$inf_insertdbrow_[54]="secsys_filter VALUES (54, 'MIIxpc',1)";
$inf_insertdbrow_[55]="secsys_filter VALUES (55, 'Mister PiX',1)";
$inf_insertdbrow_[56]="secsys_filter VALUES (56, 'moget',1)";
$inf_insertdbrow_[57]="secsys_filter VALUES (57, 'MSIECrawler',1)";
$inf_insertdbrow_[58]="secsys_filter VALUES (58, 'NetAnts',1)";
$inf_insertdbrow_[59]="secsys_filter VALUES (59, 'NetMechanic',1)";
$inf_insertdbrow_[60]="secsys_filter VALUES (60, 'NICErsPRO',1)";
$inf_insertdbrow_[61]="secsys_filter VALUES (61, 'Offline Explorer',1)";
$inf_insertdbrow_[62]="secsys_filter VALUES (62, 'Openbot',1)";
$inf_insertdbrow_[63]="secsys_filter VALUES (63, 'Openfind',1)";
$inf_insertdbrow_[64]="secsys_filter VALUES (64, 'Oracle Ultra Search',1)";
$inf_insertdbrow_[65]="secsys_filter VALUES (65, 'PerMan',1)";
$inf_insertdbrow_[66]="secsys_filter VALUES (66, 'ProPowerBot',1)";
$inf_insertdbrow_[67]="secsys_filter VALUES (67, 'ProWebwalker',1)";
$inf_insertdbrow_[68]="secsys_filter VALUES (68, 'psbot',1)";
$inf_insertdbrow_[69]="secsys_filter VALUES (69, 'Python-urllib',1)";
$inf_insertdbrow_[70]="secsys_filter VALUES (70, 'QueryN MetaSearch',1)";
$inf_insertdbrow_[71]="secsys_filter VALUES (71, 'Radiation Retriever',1)";
$inf_insertdbrow_[72]="secsys_filter VALUES (72, 'RepoMonkey',1)";
$inf_insertdbrow_[73]="secsys_filter VALUES (73, 'RMA',1)";
$inf_insertdbrow_[74]="secsys_filter VALUES (74, 'searchpreview',1)";
$inf_insertdbrow_[75]="secsys_filter VALUES (75, 'SiteSnagger',1)";
$inf_insertdbrow_[76]="secsys_filter VALUES (76, 'SpankBot',1)";
$inf_insertdbrow_[77]="secsys_filter VALUES (77, 'spanner',1)";
$inf_insertdbrow_[78]="secsys_filter VALUES (78, 'suzuran',1)";
$inf_insertdbrow_[79]="secsys_filter VALUES (79, 'Szukacz',1)";
$inf_insertdbrow_[80]="secsys_filter VALUES (80, 'Teleport',1)";
$inf_insertdbrow_[81]="secsys_filter VALUES (81, 'The Intraformant',1)";
$inf_insertdbrow_[82]="secsys_filter VALUES (82, 'TheNomad',1)";
$inf_insertdbrow_[83]="secsys_filter VALUES (83, 'TightTwatBot',1)";
$inf_insertdbrow_[84]="secsys_filter VALUES (84, 'True Robot',1)";
$inf_insertdbrow_[85]="secsys_filter VALUES (85, 'toCrawl',1)";
$inf_insertdbrow_[86]="secsys_filter VALUES (86, 'turingos',1)";
$inf_insertdbrow_[87]="secsys_filter VALUES (87, 'UrlDispatcher',1)";
$inf_insertdbrow_[88]="secsys_filter VALUES (88, 'URL_Spider_Pro',1)";
$inf_insertdbrow_[89]="secsys_filter VALUES (89, 'VCI',1)";
$inf_insertdbrow_[90]="secsys_filter VALUES (90, 'Warning',1)";
$inf_insertdbrow_[91]="secsys_filter VALUES (91, 'WebAuto',1)";
$inf_insertdbrow_[92]="secsys_filter VALUES (92, 'WebBandit',1)";
$inf_insertdbrow_[93]="secsys_filter VALUES (93, 'WebCopier',1)";
$inf_insertdbrow_[94]="secsys_filter VALUES (94, 'WebDownloader',1)";
$inf_insertdbrow_[95]="secsys_filter VALUES (95, 'WebEnhancer',1)";
$inf_insertdbrow_[96]="secsys_filter VALUES (96, 'Wget',1)";
$inf_insertdbrow_[97]="secsys_filter VALUES (97, 'Web Image Collector',1)";
$inf_insertdbrow_[98]="secsys_filter VALUES (98, 'WebmasterWorldForumBot',1)";
$inf_insertdbrow_[99]="secsys_filter VALUES (99, 'WebSauger',1)";
$inf_insertdbrow_[100]="secsys_filter VALUES (100, 'Website Quester',1)";
$inf_insertdbrow_[101]="secsys_filter VALUES (101, 'Webster',1)";
$inf_insertdbrow_[102]="secsys_filter VALUES (102, 'WebStripper',1)";
$inf_insertdbrow_[103]="secsys_filter VALUES (103, 'WebZip',1)";
$inf_insertdbrow_[104]="secsys_filter VALUES (104, 'WWW-Collector-E',1)";
$inf_insertdbrow_[105]="secsys_filter VALUES (105, 'Xenu\'s',1)";
$inf_insertdbrow_[106]="secsys_filter VALUES (106, 'Zeus',1)";
$inf_insertdbrow_[107]="secsys_filter VALUES (107, 'AntiLeech Leecher',1)";
$inf_insertdbrow_[108]="secsys_filter VALUES (108, 'HenryTheMiragoRobot',1)";

// Einfgen der Floodzeiten
$inf_insertdbrow_[109]="secsys_settings VALUES (15, 15, 15, 240, 86400, 15 , 1, 3, 1, 102, 102, 102, 102, 102, 102,1.00,1,0)";
// Einfgen der Statistiken auf Null
$inf_insertdbrow_[110]="secsys_statistics VALUES (0, 0, 0, 0)";

// Database Table Drop Command : Drop tables if infusion is uninstalled.
$inf_droptable_[1] = "secsys_filter";
$inf_droptable_[2] = "secsys_settings";
$inf_droptable_[3] = "secsys_contact";
$inf_droptable_[4] = "secsys_logfile";
$inf_droptable_[5] = "secsys_statistics";
$inf_droptable_[6] = "secsys_membercontrol";
$inf_droptable_[7] = "secsys_spamfilter";


?>
