<?php
/*----------------------------------------------+
| SECURITY SYSTEM V 1.6 FR PHP-FUSION          |
| copyright (c) 2006 by BS-Fusion Deutschland   |
| Email-Support: webmaster[at]bs-fusion.de      |
| Homepage: http://www.bs-fusion.de             |
| Inhaber: Manuel Kurz                          |
+-----------------------------------------------|
| function secsys_hacker()                      |
| copyright (c) 2005 by Christian Knerr (CBACK) |
| Homepage: http://www.cback.de                 |
+----------------------------------------------*/

if (eregi("main_control.php", $_SERVER['PHP_SELF'])) header("location:../../index.php");
if (isset($_COOKIE['fusion_user'])) {
	$sec_cookie_vars = explode(".", $_COOKIE['fusion_user']);
	$sec_cookie_1 = isNum($sec_cookie_vars['0']) ? $sec_cookie_vars['0'] : "0";
	$sec_cookie_2 = (preg_match("/^[0-9a-z]{32}$/", $sec_cookie_vars['1']) ? $sec_cookie_vars['1'] : "");
	$sec_result = dbquery("SELECT * FROM ".$db_prefix."users WHERE user_id='$sec_cookie_1' AND user_password='$sec_cookie_2'");
	unset($sec_cookie_vars,$sec_cookie_1,$sec_cookie_2);
	if (dbrows($sec_result) != 0) {
		$sysdata = dbarray($sec_result);
	}
} else {
	$sysdata = "";	$sysdata['user_level'] = 0; $sysdata['user_rights'] = ""; $sysdata['user_groups'] = "";
}
define("iSYS_SUPERADMIN",$sysdata['user_level'] == 103 ? 1 : 0);
define("SYS_FUSION_QUERY", isset($_SERVER['QUERY_STRING']) ? $_SERVER['QUERY_STRING'] : "");
define("SYS_USER_IP",$_SERVER['REMOTE_ADDR']);
define("SYS_USER_AGENT",$_SERVER['HTTP_USER_AGENT']);
define("SYS_USER_REFERER",isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : "");
define("SYS_LANG",$settings['locale']);
define("SYS_USER_ID",(isset($sysdata['user_id']) && isNum($sysdata['user_id'])) ? $sysdata['user_id'] : "0");
define("iSYS_GUEST",$sysdata['user_level'] == 0 ? 1 : 0);
define("iSYS_MEMBER", $sysdata['user_level'] >= 101 ? 1 : 0);
define("iSYS_ADMIN", $sysdata['user_level'] >= 102 ? 1 : 0);
define("iSYS_USER", $sysdata['user_level']);
define("iSYS_USER_RIGHTS", $sysdata['user_rights']);
define("iSYS_USER_GROUPS", substr($sysdata['user_groups'], 1));
      $sys_forum_id=(isset($_GET['forum_id']) && isNum($_GET['forum_id']) ? $_GET['forum_id']: "");
if (!empty($sys_forum_id)) {
	  $sys_forum_result = dbquery(
	"SELECT f.*, f2.forum_name AS forum_cat_name
	FROM ".$db_prefix."forums f
	LEFT JOIN ".$db_prefix."forums f2 ON f.forum_cat=f2.forum_id
	WHERE f.forum_id='".$sys_forum_id."'"
);
if (dbrows($sys_forum_result)) {
	$sys_fdata = dbarray($sys_forum_result);
$sys_forum_mods = explode(".", $sys_fdata['forum_moderators']);
if (iSYS_MEMBER && in_array($sysdata['user_id'], $sys_forum_mods)) { define("iSYSMOD", true); } else { define("iSYSMOD", false); }	
}
}

define("SEC_INFDIR",INFUSIONS."security_system/");

// Funktion zur berprfung, ob eine Infusion installiert ist.
// Diese Funktion kann bereits bei dem Hochladen dieser Infusion und der nderung der
// maincore.php eingesetzt werden.

function check_infusion($inf_pan) {
$rsl_inf=dbrows(dbquery("SELECT * FROM ".DB_PREFIX."infusions WHERE inf_folder='$inf_pan'"));
if ($rsl_inf!=0) {
  return true;
} else {return false;}
}

// Check if user is assigned to the specified user group
function checksysgroup($group) {
	if (iSYS_SUPERADMIN && ($group == "0" || $group == "101" || $group == "102" || $group == "103")) { return true; }
	elseif (iSYS_ADMIN && ($group == "0" || $group == "101" || $group == "102")) { return true; }
	elseif (iSYS_MEMBER && ($group == "0" || $group == "101")) { return true; }
	elseif (iSYS_GUEST && $group == "0") { return true; }
	elseif (iSYS_MEMBER && in_array($group, explode(".", iSYS_USER_GROUPS))) {
		return true;
	} else {
		return false;
	}
}


// Bei erfolgreicher Prfung, startet das Security System ab hier
if (check_infusion("security_system")) {
// Einbinden der Sprachdaten
if (file_exists(INFUSIONS . "security_system/locale/".$settings['locale'].".php")) {
	include INFUSIONS . "security_system/locale/".$settings['locale'].".php";
}
else {
 	include INFUSIONS . "security_system/locale/Polish.php";
}
/*----------------------------------------------------------------+
| Ohne eine Aktzeptierung der Lizenzvereinbarungen wird nur die   |
| SQL-Injection von CBACK ausgefhrt, da diese Funktion nicht     |
| Eigentum von BS-Fusion ist und unter der Lizenz der GPL steht.  |
+----------------------------------------------------------------*/
// Funktion fr die SQL-Injection-Blockade
function secsys_hacker() {
 $rules = array('chr(', 'chr=', 'chr%20', '%20chr', 'wget%20', '%20wget', 'wget(','wget',
 			       'cmd=', '%20cmd', 'cmd%20', 'rush=', '%20rush', 'rush%20',
                   'union%20', '%20union', 'union(', 'union=', 'echr(', '%20echr', 'echr%20', 'echr=',
                   'esystem(', 'esystem%20', 'cp%20', '%20cp', 'cp(', 'mdir%20', '%20mdir', 'mdir(',
                   'mcd%20', 'mrd%20', 'rm%20', '%20mcd', '%20mrd', '%20rm',
                   'mcd(', 'mrd(', 'rm(', 'mcd=', 'mrd=', 'mv%20', 'rmdir%20', 'mv(', 'rmdir(',
                   'chMOD/INFUSION(', 'chMOD/INFUSION%20', '%20chMOD/INFUSION', 'chMOD/INFUSION(', 'chMOD/INFUSION=', 'chown%20', 'chgrp%20', 'chown(', 'chgrp(',
                   'locate%20', 'grep%20', 'locate(', 'grep(', 'diff%20', 'kill%20', 'kill(', 'killall',
                   'passwd%20', '%20passwd', 'passwd(', 'telnet%20', 'vi(', 'vi%20',
                   'insert%20into', 'select%20', 'nigga(', '%20nigga', 'nigga%20', 'fopen', 'fwrite', '%20like', 'like%20',
                   '$_request', '$_get', '$request', '$get', '.system', 'http_php', '&aim', '%20getenv', 'getenv%20',
                   'new_password', '&icq','/etc/password','/etc/shadow', '/etc/groups', '/etc/gshadow',
                   'http_user_agent', 'http_host', '/bin/ps', 'uname\x20-a', '/usr/bin/id',
                   '/bin/echo', '/bin/kill', '/bin/', '/chgrp', '/chown', '/usr/bin', 'g\+\+', 'bin/python',
                   'bin/tclsh', 'bin/nasm', 'perl%20', 'traceroute%20', 'ping%20', '.pl', '/usr/x11r6/bin/xterm', 'lsof%20',
                   '/bin/mail', '.conf', 'motd%20', 'http/1.', '.inc.php', 'maincore.php','config.php', 'cgi-', '.eml',
                   'file\://', 'window.open', '<script>', 'javascript\://','img src', 'img%20src','.jsp','ftp.exe',
                   'xp_enumdsn', 'xp_availablemedia', 'xp_filelist', 'xp_cmdshell', 'nc.exe', '.htpasswd',
                   'servlet', '/etc/passwd', 'wwwacl', '~root', '~ftp', '.js', '.jsp', '.history',
                   'bash_history', '.bash_history', '~nobody', 'server-info', 'server-status', 'reboot%20', 'halt%20',
                   'powerdown%20', '/home/ftp', '/home/www', 'secure_site, ok', 'chunked', 'org.apache', '/servlet/con',
                   '<script', '/robots.txt','/robot.txt' ,'/perl' ,'MOD/INFUSION_gzip_status', 'db_mysql.inc', '.inc', 'select%20from',
                   'select from', 'drop%20', '.system', 'getenv', 'http_', '_php', 'php_', 'phpinfo()', '<?php', '?>', 'sql=',
                   '_global', 'global_', 'global[', '_server', 'server_', 'server[', '/MOD/INFUSIONules', 'MOD/INFUSIONules/', 'phpadmin',
                   'root_path', '_globals', 'globals_', 'globals[', 'ISO-8859-1', '?hl=', '.txt', '.exe', 
        				    'ISO-','<iframe',"'");

  $syshack = SYS_FUSION_QUERY;
  $syshack2 = strtolower($syshack);
  $syscheck  = str_replace($rules, 'hAcKR', $syshack2);

  if($syshack2 != $syscheck)
  {
          $user_agent=str_replace('||', ' ', SYS_USER_AGENT);

          $rsl=dbrows(dbquery("SELECT * FROM ".DB_PREFIX."secsys_logfile WHERE hack_ip='".SYS_USER_IP."' AND hack_type='hacks' AND hack_datestamp>='".(time()-3600)."'"));
          if ($rsl==0) {
          $sys_msg=stripinput(SYS_FUSION_QUERY);
          $sys_msg=substr($sys_msg,0,75).(strlen($sys_msg)>75 ? "..." : "");
          $sys_msg_entry=eregi_replace(" ","",$sys_msg);
          $result=dbquery("INSERT INTO ".DB_PREFIX."secsys_logfile (hack_id,hack_type,hack_userid,hack_ip,hack_query,hack_referer,hack_agent,hack_datestamp) VALUES (NULL,'hacks','".SYS_USER_ID."','".SYS_USER_IP."','".$sys_msg_entry."','".stripinput(SYS_USER_REFERER)."','".$user_agent."','".time()."')");
          }
          $result=dbquery("UPDATE ".DB_PREFIX."secsys_statistics SET hacks=hacks+1");
          mysql_close();
          fallback(SEC_INFDIR."attack.html");
         
  }
}

if (!iSYS_ADMIN && SYS_USER_REFERER=="") {
secsys_hacker();     // SQL-Injection
}


// Aufrufen der Systemeinstellungen
$sys_setting = dbarray(dbquery("SELECT * from ".$db_prefix."secsys_settings"));
if ($sys_setting['license_accept']>0) {

// Funktion fr die IP/Agent-Blockade
function secsys_filter() {
  $b_remotead = SYS_USER_IP;
  $b_agent    = SYS_USER_AGENT;
  if(!empty($b_remotead) || !empty($b_agent))
  {
    $result = dbquery("SELECT list FROM " .DB_PREFIX."secsys_filter WHERE active='1'");
    $listnum=dbrows($result);
    if ($listnum>0) {
    $i=0;
    while($i<=$listnum) {
    $agent=dbresult($result,$i)."||";
    $i++;
    $test=explode("||",$agent);
      foreach($test as $key) {
        if (!empty($key)) {
          $check=eregi($key,$b_agent);
          $check2=eregi($key,$b_remotead);
          if (!empty($check) || !empty($check2)) {
          $user_agent=str_replace('||', ' ', SYS_USER_AGENT);
          $rsl=dbrows(dbquery("SELECT * FROM ".DB_PREFIX."secsys_logfile WHERE hack_ip='".SYS_USER_IP."' AND hack_type='blocks' AND hack_datestamp>='".(time()-3600)."'"));
          if ($rsl==0) {
          $sys_msg=stripinput(SYS_FUSION_QUERY);
          $sys_msg=substr($sys_msg,0,75).(strlen($sys_msg)>75 ? "..." : "");
          $sys_msg_entry=eregi_replace(" ","",$sys_msg);
          $result=dbquery("INSERT INTO ".DB_PREFIX."secsys_logfile (hack_id,hack_type,hack_userid,hack_ip,hack_query,hack_referer,hack_agent,hack_datestamp) VALUES (NULL,'blocks','".SYS_USER_ID."','".SYS_USER_IP."','".$sys_msg_entry."','".stripinput(SYS_USER_REFERER)."','".$user_agent."','".time()."')");
          }
          $result=dbquery("UPDATE ".DB_PREFIX."secsys_statistics SET blocks=blocks+1");
          mysql_close();
          fallback(SEC_INFDIR."filterstop.html");
         }
        }
      }
     }
    }
  }
}


function secsys_spamcontrol($msg) {
$result=dbquery("SELECT spam_word FROM ".DB_PREFIX."secsys_spamfilter");
    $listnum=dbrows($result);
    if ($listnum>0)
    {
     $i=0;
     while($i<=$listnum)
     {
     $spamword=dbresult($result,$i)."||";
     $i++;
     $test=explode("||",$spamword);
      foreach($test as $key)
      {
        if (!empty($key))
        {
          $sysspam = strtolower($_POST[$msg]);
          $syscheck  = str_replace($key, 'SPAMCONTROL', $sysspam);
          if (eregi("SPAMCONTROL",$syscheck))
          {
          $user_agent=str_replace('||', ' ', SYS_USER_AGENT);
          $rsl=dbrows(dbquery("SELECT * FROM ".DB_PREFIX."secsys_logfile WHERE hack_ip='".SYS_USER_IP."' AND hack_type='spam' AND hack_datestamp>='".(time()-3600)."'"));
          if ($rsl==0) {
          $spam_msg=strip_tags($_POST[$msg]);
          $sys_msg=substr($spam_msg,0,75).(strlen($spam_msg)>75 ? "..." : "");
          $sys_msg_entry=eregi_replace(" ","",$sys_msg);
          $result=dbquery("INSERT INTO ".DB_PREFIX."secsys_logfile (hack_id,hack_type,hack_userid, hack_ip,hack_query,hack_referer,hack_agent,hack_datestamp) VALUES (NULL,'spam','".SYS_USER_ID."','".SYS_USER_IP."','".$sys_msg_entry."','".stripinput(SYS_USER_REFERER)."','".$user_agent."','".time()."')");
          }
          $result=dbquery("UPDATE ".DB_PREFIX."secsys_statistics SET spams=spams+1");
         mysql_close();
         fallback(SEC_INFDIR."spamstop.html");
        }
      }
     }
    }
   }
}

// Funktionen der Spamkontrolle der einzelnen Bereiche
function forum_control($userid,$ipaddress) {
 global $db_prefix, $sys_setting;
 $floodtime=time()-$sys_setting['fctime'];
 if($userid) {
 $result=dbquery("SELECT post_id FROM ".$db_prefix."posts WHERE post_author='$userid' AND post_datestamp>='".$floodtime."'");	
 }
 else {
 $result=dbquery("SELECT post_id FROM ".$db_prefix."posts WHERE post_ip='$ipaddress' AND post_datestamp>='".$floodtime."'");	}
 if(dbrows($result)>0){ return true;}else{ return false;	}
}

function shoutbox_control ($userid,$ipaddress) {
 global $db_prefix, $sys_setting;
  $floodtime=time()-$sys_setting['sctime'];
 if($userid) {
 $result=dbquery("SELECT shout_id FROM ".$db_prefix."shoutbox WHERE shout_name='$userid' AND shout_datestamp>='".$floodtime."'");	
 }
 else {
 $result=dbquery("SELECT shout_id FROM ".$db_prefix."shoutbox WHERE shout_ip='$ipaddress' AND shout_datestamp>='".$floodtime."'");	}
 if(dbrows($result)>0){ return true;}else{ return false;	}
}

function comment_control ($userid,$ipaddress) {
 global $db_prefix, $sys_setting;
  $floodtime=time()-$sys_setting['cctime'];
 if($userid) {
 $result=dbquery("SELECT comment_id FROM ".$db_prefix."comments WHERE comment_name='$userid' AND comment_datestamp>='".$floodtime."'");	
 }
 else {
 $result=dbquery("SELECT comment_id FROM ".$db_prefix."comments WHERE comment_ip='$ipaddress' AND comment_datestamp>='".$floodtime."'");	}
 if(dbrows($result)>0){ return true;}else{ return false;	}
}

function guestbook_control ($ipaddress) {
 global $db_prefix, $sys_setting;
 $floodtime=time()-$sys_setting['gctime'];
 $result=dbquery("SELECT guestbook_id FROM ".$db_prefix."guestbook WHERE guestbook_ip='$ipaddress' AND guestbook_datestamp>='".$floodtime."'");
 if(dbrows($result)>0 || dbrows($result2)>0 ){ return true;}else{ return false;	}
}


function pm_control ($userid,$userid2) {
 global $db_prefix, $sys_setting;
  $floodtime=time()-$sys_setting['mctime'];
  $result=dbquery("SELECT message_id FROM ".$db_prefix."messages WHERE message_from='$userid' AND message_to='$userid2' AND message_datestamp>='".$floodtime."'");	
 if(dbrows($result)>0){ return true;}else{ return false;	}
}

function contact_control ($contact_ip,$contact_time) {
global $db_prefix, $sys_setting;
$floodtime=time()-$sys_setting['coctime'];
       if (!empty($contact_ip)) {
       $result = dbquery("SELECT * from ".$db_prefix."secsys_contact WHERE contact_datestamp>='".$floodtime."' AND contact_ip='$contact_ip'");
        if(dbrows($result)>0){
        unset($_POST['sendmessage']);
        return true;}else{
        $result2=dbquery("INSERT INTO ".$db_prefix."secsys_contact (contact_datestamp,contact_ip) VALUES('".time()."','$contact_ip')");
        return false;}
       }
}

// Funktion zur Eintragung der Spam/Flood-Eintrge
function print_flood() {
global $sysdata, $db_prefix,$sys_setting;
          $user_agent=str_replace('||', ' ', SYS_USER_AGENT);
          $rsl=dbrows(dbquery("SELECT * FROM ".DB_PREFIX."secsys_logfile WHERE hack_ip='".SYS_USER_IP."' AND hack_type='floods' AND hack_datestamp>='".(time()-3600)."'"));
          if ($rsl==0) {
          $sys_msg=FUSION_QUERY;
          $sys_msg=substr($sys_msg,0,75).(strlen($sys_msg)>75 ? "..." : "");
          $sys_msg_entry=eregi_replace(" ","",$sys_msg);
          $result=dbquery("INSERT INTO ".DB_PREFIX."secsys_logfile (hack_id,hack_type,hack_userid,hack_ip,hack_query,hack_referer,hack_agent,hack_datestamp) VALUES (NULL,'floods','".SYS_USER_ID."','".SYS_USER_IP."','".$sys_msg."','".SYS_USER_REFERER."','".$user_agent."','".time()."')");
          }
          $result=dbquery("UPDATE ".DB_PREFIX."secsys_statistics SET floods=floods+1");

     if ($sys_setting['userlock']>0 && (iSYS_MEMBER && !iSYS_ADMIN)) {
          $control_member=dbcount("(c_user_id)","secsys_membercontrol","c_user_id='".SYS_USER_ID."'");
          if ($control_member==0) {
          $result=dbquery("INSERT INTO ".$db_prefix."secsys_membercontrol (c_user_id,c_flood_count,c_userlock,c_userlock_datestamp) VALUES ('".SYS_USER_ID."','0','0','".time()."')");
          }
          elseif ($control_member>0) {
          $rsl=dbarray(dbquery("SELECT * from ".$db_prefix."secsys_membercontrol WHERE c_user_id='".SYS_USER_ID."'"));
          $flood_stop=$rsl['c_flood_count'];
          }

          if ($flood_stop<$sys_setting['user_attempts']) {
          $mem_upd=dbquery("UPDATE ".$db_prefix."secsys_membercontrol SET c_flood_count=c_flood_count+1 WHERE c_user_id='".SYS_USER_ID."'");
          }
    }
}

if (!iSYS_SUPERADMIN) {
secsys_filter();     // IP/AGENT-Blocker
}

if (!checksysgroup("101")) {
      if (!empty($_POST['message']))
      {secsys_spamcontrol('message');}
      if (!empty($_POST['shout_message']))
      {secsys_spamcontrol('shout_message');}
      if (!empty($_POST['guest_message']))
      {secsys_spamcontrol('guest_message');}
      if (!empty($_POST['comment_message']))
      {secsys_spamcontrol('comment_message');}
}

if ($sys_setting['flood_active']>0)
 {
      // Floodeintrge stoppen
      // Forum, Kontakt und Private Mitteilungen
      if (isset($_POST['message']) && (!isset($_POST['previewpost'])&&!isset($_POST['previewreply'])&&!isset($_POST['previewchanges'])&&!isset($_POST['savechanges'])))
      {

      if (eregi("/forum/",FUSION_REQUEST)) {
        if (!checksysgroup($sys_setting['forum_access']) && !iSYSMOD) {
          if (forum_control(SYS_USER_ID,$_SERVER['REMOTE_ADDR']))
          {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=forum");
          }
        }
      }
      elseif (eregi("messages.php",FUSION_SELF)) {
        if (!checksysgroup($sys_setting['pm_access'])) {
          if (pm_control($sysdata['user_id'],$_POST['msg_send']))
          {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=pm");
          }
        }
        }
      elseif (eregi("contact.php",FUSION_SELF)) {
        if (!checksysgroup($sys_setting['contact_access']))
        {
          if (contact_control(SYS_USER_IP,time()))
          {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=contact");
          }
        }
      }
        
      }

      // Shoutbox
      if (isset($_POST['shout_message']))
      {

        if (!checksysgroup($sys_setting['shout_access'])) {
          if (shoutbox_control($sysdata['user_id'],$_SERVER['REMOTE_ADDR']))
          {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=shout");
          }
        }
      }

      // Gstebuch
      if (eregi("guestbook.php",FUSION_SELF)) {
      if (isset($_POST['guest_message']))
      {
       if (!checksysgroup($sys_setting['gb_access'])) {
          if (guestbook_control($_SERVER['REMOTE_ADDR']))
          {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=guestbook");
          }
        }
      }
      }
      // Kommententare
      if (isset($_POST['comment_message']))
      {
        if (!checksysgroup($sys_setting['comment_access'])) {
          if (comment_control($sysdata['user_id'],$_SERVER['REMOTE_ADDR'])) {
          print_flood();
          fallback(INFUSIONS."security_system/restrict.php?check=comments");
          }
        }
      }
  }
}
}
?>
